

open Core

let process_single_file fname = 
  try
  let content = In_channel.read_all fname in
let processed = Lexer.lex_string content in
let rawparsed = Parse.rawparse processed in
let elaborated = Elborate.elaborateDec rawparsed in
let type_reconstructed = TypeReconstruct.typecheckSig elaborated in
(* [%derive.show: Parseast.parseast] rawparsed *)
(* Parseast.debugshow rawparsed *)
(* [%derive.show: Parseast.parseast] rawparsed *)
(* Ast.ds_decl elaborated *)
let _ = print_endline (Ast.ds_decl type_reconstructed) in
let _ =  print_endline "%% OK %%" in
let _ =  print_endline "====================================" in
let _ =  print_endline "** CoLF₂ Logic Programming Engine **" in
let _ =  print_endline "====================================" in
let _ =  print_endline "Please type a single declaration in the form of `proof : Query.`" in
LogicProgramming.loop type_reconstructed

  with Failure s -> 
    (let s = s in
    TypeCheckingContext.ds_reset_ctx_printing(); 
    print_endline ("FAILED: " ^ s); failwith "Exception Printed"
    )
(* ([%derive.show: Token.tok list] processed) *)
